<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class Admin_Code_Block_Controller extends Admin_Controller {
  public function index() {
    print $this->_get_view();
  }

  public function handler() {
    access::verify_csrf();

    $form = $this->_get_form();
    if ($form->validate()) {
      module::set_var(
        "code_block", "code", stripslashes($_REQUEST["code_block"])); // var directly to get around xss filtering.
      module::set_var(
        "code_block", "title", $form->code_block->code_title->value);
      module::set_var(
        "code_block", "onphoto", $form->code_block->code_onphoto->value);
      module::set_var(
        "code_block", "onalbum", $form->code_block->code_onalbum->value);
	  module::set_var(
        "code_block", "onall", $form->code_block->code_onall->value);
        
      module::set_var(
        "code_block", "code2", stripslashes($_REQUEST["code_block2"])); // var directly to get around xss filtering.
      module::set_var(
        "code_block", "title2", $form->code_block2->code_title2->value);
      module::set_var(
        "code_block", "onphoto2", $form->code_block2->code_onphoto2->value);
      module::set_var(
        "code_block", "onalbum2", $form->code_block2->code_onalbum2->value);
	  module::set_var(
        "code_block", "onall2", $form->code_block2->code_onall2->value);
        
      module::set_var(
        "code_block", "code3", stripslashes($_REQUEST["code_block3"])); // var directly to get around xss filtering.
      module::set_var(
        "code_block", "title3", $form->code_block3->code_title3->value);
      module::set_var(
        "code_block", "onphoto3", $form->code_block3->code_onphoto3->value);
      module::set_var(
        "code_block", "onalbum3", $form->code_block3->code_onalbum3->value);
	  module::set_var(
        "code_block", "onall3", $form->code_block3->code_onall3->value);

      module::set_var(
        "code_block", "code4", stripslashes($_REQUEST["code_block4"])); // var directly to get around xss filtering.
      module::set_var(
        "code_block", "title4", $form->code_block4->code_title4->value);
      module::set_var(
        "code_block", "onphoto4", $form->code_block4->code_onphoto4->value);
      module::set_var(
        "code_block", "onalbum4", $form->code_block4->code_onalbum4->value);
	  module::set_var(
        "code_block", "onall4", $form->code_block4->code_onall4->value);
        
      message::success(t("Your settings have been saved."));  
      url::redirect("admin/code_block");
    }

    print $this->_get_view($form);
  }

  private function _get_view($form=null) {
    $v = new Admin_View("admin.html");
    $v->content = new View("admin_code_block.html");
    $v->content->form = empty($form) ? $this->_get_form() : $form;
    return $v;
  }

  private function _get_form() {
    $form = new Forge("admin/code_block/handler", "", "post", array("id" => "g-admin-form"));
    
	$group = $form->group("code_block")->label(t("Code block"));
    $group->input("code_title")->label(t('Enter the title of the block.'))
		->value(module::get_var("code_block", "title"));
    $group->textarea("code_block")->label(t('Enter the standard HTML code you want in the block.'))
		->value(module::get_var("code_block", "code"));
	$group->checkbox("code_onphoto")->label(t("Show on photo pages"))
      ->checked(module::get_var("code_block", "onphoto", false) == 1);
	$group->checkbox("code_onalbum")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("code_block", "onalbum", false) == 1);
	$group->checkbox("code_onall")->label(t("Show on all pages"))
      ->checked(module::get_var("code_block", "onall", false) == 1);
	  
	$group = $form->group("code_block2")->label(t("Code block 2"));
    $group->input("code_title2")->label(t('Enter the title of the 2nd block.'))
		->value(module::get_var("code_block", "title2"));
    $group->textarea("code_block2")->label(t('Enter the standard HTML code you want in the 2nd block.'))
		->value(module::get_var("code_block", "code2"));
	$group->checkbox("code_onphoto2")->label(t("Show on photo pages"))
      ->checked(module::get_var("code_block", "onphoto2", false) == 1);
	$group->checkbox("code_onalbum2")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("code_block", "onalbum2", false) == 1);
	$group->checkbox("code_onall2")->label(t("Show on all pages"))
      ->checked(module::get_var("code_block", "onall2", false) == 1);
    
    $group = $form->group("code_block3")->label(t("Code block 3"));
    $group->input("code_title3")->label(t('Enter the title of the 3rd block.'))
		->value(module::get_var("code_block", "title3"));
    $group->textarea("code_block3")->label(t('Enter the standard HTML code you want in the 3rd block.'))
		->value(module::get_var("code_block", "code3"));
	$group->checkbox("code_onphoto3")->label(t("Show on photo pages"))
      ->checked(module::get_var("code_block", "onphoto3", false) == 1);
	$group->checkbox("code_onalbum3")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("code_block", "onalbum3", false) == 1);
	$group->checkbox("code_onall3")->label(t("Show on all pages"))
      ->checked(module::get_var("code_block", "onall3", false) == 1);

    $group = $form->group("code_block4")->label(t("Code block 4"));
    $group->input("code_title4")->label(t('Enter the title of the 4th block.'))
		->value(module::get_var("code_block", "title3"));
    $group->textarea("code_block4")->label(t('Enter the standard HTML code you want in the 4th block.'))
		->value(module::get_var("code_block", "code4"));
	$group->checkbox("code_onphoto4")->label(t("Show on photo pages"))
      ->checked(module::get_var("code_block", "onphoto4", false) == 1);
	$group->checkbox("code_onalbum4")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("code_block", "onalbum4", false) == 1);
	$group->checkbox("code_onall4")->label(t("Show on all pages"))
      ->checked(module::get_var("code_block", "onall4", false) == 1);
      
    $form->submit("submit")->value(t("Save"));
    return $form;
  }
}